// Second.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "cmath"
#include "locale.h"
#include "iostream"
using namespace std;

class Pair
{
public:
	virtual void input() = 0;
	virtual void output() = 0;
    virtual void add() = 0;
	virtual void sub() = 0;
	virtual void mul() = 0;
	virtual void div() = 0;
	virtual void conj() = 0;
	virtual void equ() = 0;
};

class Complex: public Pair
{
private: 
	double a;
	double b;
	double c;
	double d;
public:
	virtual void input()
		{   
			cout << "   A+iB: ";
			cin >> a >> b;
			cout << "   +iD: ";
			cin >> c >> d;
		}
	virtual void output()
		{   
			cout << "  A+iB: "<< "(" << a << "," <<b << ")\n";
			cout << "  C+iD: "<< "(" << c << "," <<d << ")";
		}
	virtual void add()
		{   
			cout << "C: (" << a+c << "," <<b+d << ")";
		}
	virtual void sub()
		{   
			cout << ": (" << a-c << "," <<b-d << ")";
		}
	virtual void mul()
		{   
			cout << ": (" << a*c-b*d << "," <<a*d+b*c << ")";
		}
	virtual void div()
		{   
			cout << ": (" << (a*c+b*d)/(c*c+d*d) << "," <<(b*c-a*d)/(c*c+d*d) << ")";
		}
	virtual void conj()
		{   
			cout << "  A+iB: (" << a << "," << -b << ")\n";
			cout << "  C+iD: (" << c << "," << -d << ")";
		}
	virtual void equ()
		{   
			if (a==c&&b==d) cout << " ";
			else cout << "  ";
		}
};

class FazzyNumber: public Pair
{
private: 
	double x;
	double a;
	double b;
	double y;
	double c;
	double d;
public:
	virtual void input()
		{   
			cout << "   (X-a,X,X-b): ";
			cin >> a >> x >> b;
			cout << "   (Y-c,Y,Y-d): ";
			cin >> c >> y >> d;
		}
	virtual void output()
		{   
			cout << "  (X-a,X,X-b): "<< "(" << x-a << "," << x << "," << x-b << ")\n";
			cout << "  (Y-c,Y,Y-d): "<< "(" << y-c << "," << y << "," << y-d << ")";
		}
	virtual void add()
		{   
			cout << ": (" << x+y-a-c << "," << x+y << "," << x+y+b+d << ")";
		}
	virtual void sub()
		{   
			cout << ": (" << x-y-a-c << "," << x-y << "," << x-y+b+d << ")";
		}
	virtual void mul()
		{   
			cout << ": (" << x*y-y*a-x*c+a*c << "," << x*y << "," << x*y+y*a+x*c+a*c << ")";
		}
	virtual void div()
		{   
			cout << ": (" << (x-a)/(y+d) << "," << x/y << "," << (x+b)/(y-c) << ")";
		}
	virtual void conj()
		{   
			cout << "  (X-a,X,X-b): (" << 1/(x+b) << "," << 1/x << "," << 1/(x-a) << ")\n";
			cout << "  (Y-c,Y,Y-d): (" << 1/(y+d) << "," << 1/y << "," << 1/(y-c) << ")";
		}
	virtual void equ()
		{   
			if (a==c&&b==d&&x==y) cout << " ";
			else cout << "  ";
		}
};


int _tmain(int argc, _TCHAR* argv[])
{
	setlocale(LC_ALL, "Russian");
	char number;
	ReClass:cout << "     ?\n1..\n2.\n";
	cin >> number;
	Pair *p;
	if (number == '1') p = new Complex;
	else if (number == '2') p = new FazzyNumber;
	else {
			cout << "  \n";
			goto ReClass;
		 }			
	p->input();
	char choise;
	do {
		cout << "\n   ?\n1.   .\n2. .\n3. .\n4. .\n5. .\n6. .\n7.  .\n8. .\n9.   .\n0..\n";
		cin >> choise;
		switch(choise){
			case '1':
				p->output();
				break;
			case '2':
				p->input();
				break;
			case '3':
				p->add();
				break;
			case '4':
				p->sub();
				break;
			case '5':
				p->mul();
				break;
			case '6':
				p->div();
				break;
			case '7':
				p->conj();
				break;
			case '8':
				p->equ();
				break;
			case '9':
				goto ReClass; 
				break;
			default:
				if(choise!='0') cout << "\n ,    0  9\n";
		}
	} while(choise!='0');
	return 0;
}

